## ros-indigo-ueye-cam 1.0.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(ueye_cam)

# C++11 Needed
include(CheckCXXCompilerFlag)

CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)

if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

find_package(catkin REQUIRED COMPONENTS
  roscpp
  nodelet
  dynamic_reconfigure
  image_transport
  sensor_msgs
  camera_calibration_parsers
  camera_info_manager
  )
catkin_destinations() # define ${CATKIN_PACKAGE_SHARE_DESTINATION}

#set(UEYE_LIBRARY_PATH /usr/lib)
find_library(UEYE_LIBRARY ueye_api)
set(USE_UNOFFICIAL_UEYE_DRIVERS FALSE)
if(NOT UEYE_LIBRARY)
  message(STATUS "libueye_api was not found in system's library path")
  #include(cmake_modules/DownloadUEyeDrivers.cmake)
  include(cmake_modules/DownloadUEyeDriversUnofficial.cmake)
  set(UEYE_DRIVER_DIR ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION})
  if(UEYE_DRIVER_DIR)
    message(STATUS "Setting UEYE_DRIVER_DIR to: ${UEYE_DRIVER_DIR}")
  else()
    set(UEYE_DRIVER_DIR ${CMAKE_CURRENT_BINARY_DIR})
    message(STATUS "Failed to set UEYE_DRIVER_DIR to: CATKIN_DEVEL_PREFIX/CATKIN_PACKAGE_SHARE_DESTINATION, defaulting to CMAKE_CURRENT_BINARY_DIR: ${UEYE_DRIVER_DIR}")
  endif()
  download_ueye_drivers(UEYE_LIBRARY UEYE_INCLUDE_DIR ${UEYE_DRIVER_DIR})
  message(STATUS "libueye_api library: ${UEYE_LIBRARY}")
  message(STATUS "libueye_api include: ${UEYE_INCLUDE_DIR}")
  set(USE_UNOFFICIAL_UEYE_DRIVERS TRUE)
endif()

set(UEYECAM_NODELET_NAME ueye_cam_nodelet)
set(UEYECAM_LIB_NAME ueye_wrapper)

set(UEYECAM_LIB_SOURCES
  src/ueye_cam_driver.cpp
)

set(UEYECAM_LIB_HEADERS
  include/ueye_cam/logging_macros.hpp
  include/ueye_cam/ueye_cam_driver.hpp
)

set(UEYECAM_NODELET_SOURCES
  src/ueye_cam_nodelet.cpp
)

set(UEYECAM_NODELET_HEADERS
  include/ueye_cam/ueye_cam_nodelet.hpp
)

generate_dynamic_reconfigure_options(
  cfg/UEyeCam.cfg
  )

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${UEYECAM_LIB_NAME} ${UEYECAM_NODELET_NAME}
  CATKIN_DEPENDS roscpp nodelet dynamic_reconfigure image_transport sensor_msgs camera_calibration_parsers camera_info_manager
  )

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${UEYE_INCLUDE_DIR}
  )


add_library(${UEYECAM_LIB_NAME} ${UEYECAM_LIB_SOURCES} ${UEYECAM_LIB_HEADERS})
target_link_libraries(${UEYECAM_LIB_NAME} ${catkin_LIBRARIES} ${UEYE_LIBRARY})

add_library(${UEYECAM_NODELET_NAME} ${UEYECAM_NODELET_SOURCES} ${UEYECAM_NODELET_HEADERS})
target_link_libraries(${UEYECAM_NODELET_NAME} ${catkin_LIBRARIES} ${UEYECAM_LIB_NAME})
add_dependencies(${UEYECAM_NODELET_NAME} ${PROJECT_NAME}_gencfg)

add_executable(check_ueye_api src/check_ueye_api.cpp)
target_link_libraries(check_ueye_api ${catkin_LIBRARIES} ${UEYECAM_LIB_NAME})

# Do not package the barebones IDS drivers, since they will mask over the official drivers (when present)
#if(USE_UNOFFICIAL_UEYE_DRIVERS)
#  get_filename_component(UNOFFICIAL_UEYE_DRIVERS_LIB_REALPATH ${UEYE_LIBRARY} REALPATH)
#  install(FILES ${UEYE_LIBRARY} ${UNOFFICIAL_UEYE_DRIVERS_LIB_REALPATH}
#    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
#endif()

# Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS ${UEYECAM_LIB_NAME} ${UEYECAM_NODELET_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  )

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  )

=== debian/changelog ===
ros-indigo-ueye-cam (1.0.15-0trusty) trusty; urgency=high

  * recover + update from failure in setColorMode
  * extended color modes (10, 12, 16 bit per channel)
  * added timeout topic for better debugging of frame timeouts
  * Contributors: Anqi Xu, Dominik Klein

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 25 Aug 2016 04:00:00 -0000

ros-indigo-ueye-cam (1.0.14-0trusty) trusty; urgency=high

  * now attempting to link against 32-bit ARMHF IDS libs on ARM64 arch
  * added capability to detect ARM64 processor (aarch64)
  * added separate rates for polling frames vs publishing images
  * fixed buffersize for subsampling and increased maximum image size availible via rqt
  * added Travis CI config
  * Contributors: Anqi Xu, Eddy, Isaac I.Y. Saito, francois

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 26 May 2016 04:00:00 -0000

ros-indigo-ueye-cam (1.0.13-0trusty) trusty; urgency=high

  * Change timestamp source based on issue https://github.com/anqixu/ueye_cam/issues/37
  * changed 'failure to set active-low flash' from error to warning
  * Fixed typo in Gain for dynamic reconfigure parameters
  * Updated pixel_clock cap in dyncfg settings
  * Added check_ueye_api to confirm availability of IDS SDK at runtime
  * Contributors: Anqi Xu, Anup, Aris Synodinos, Kei Okada

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Fri, 13 May 2016 04:00:00 -0000

ros-indigo-ueye-cam (1.0.12-0trusty) trusty; urgency=high

  * fixed binning IS_INVALID_BUFFER_SIZE bug
  * Modified nodelet to use camera timestamp instead of wall clock time
  * Fix for new upstream dir name on ARM
  * Contributors: Alejandro Merello, Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 28 Sep 2015 04:00:00 -0000

ros-indigo-ueye-cam (1.0.11-0trusty) trusty; urgency=high

  * updated barebones IDS drivers to 4.61
  * removed barebones IDS drivers from debian packaging
  * Added proper checking for C++11 features on compilers
  * Performed minor code cleanup, updated old PLUGINLIB_DECLARE_CLASS to
    newer PLUGINLIB_EXPORT_CLASS
  * Contributors: Anqi Xu, Aris Synodinos

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 17 Aug 2015 04:00:00 -0000

ros-indigo-ueye-cam (1.0.10-0trusty) trusty; urgency=high

  * fixed setting synchronization bugs during camera initialization
  * added support for (packed) BGR8 color mode
  * failing to set non-essential parameters will no longer prematurily terminate nodelet
  * updated printouts to be more verbose and consistent
  * fix for reported ARM arch on Fedora
  * Contributors: Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 06 Aug 2015 04:00:00 -0000

ros-indigo-ueye-cam (1.0.9-0trusty) trusty; urgency=high

  * fixed lagged changes to flip_upd and flip_lr via rqt_reconfigure
  * Support discrete-only pixelclocks cameras
  * Ask if gainboost is supported first
  * Switched to jbohren's version of the file(GENERATE...) fix
  * Contributors: Anqi Xu, Fran Real, Jonathan Bohren

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Tue, 03 Feb 2015 05:00:00 -0000

ros-indigo-ueye-cam (1.0.8-0trusty) trusty; urgency=high

  * switched from cmake's file(GENERATE ...) to execute_command(cp ...), to accommodate cmake 2.8.x on Saucy
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 08 Jan 2015 05:00:00 -0000

ros-indigo-ueye-cam (1.0.7-0trusty) trusty; urgency=high

  * continuing to address issues on ROS bin buildfarm
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 22 Dec 2014 05:00:00 -0000

ros-indigo-ueye-cam (1.0.6-0trusty) trusty; urgency=high

  * continuing to trying to fix errors on ROS buildfarm
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 18 Dec 2014 05:00:00 -0000

ros-indigo-ueye-cam (1.0.5-0trusty) trusty; urgency=high

  * fixed/improved unofficial driver install; added warning messages during compile- & run-time to note that unofficially-installed drivers will allow ueye_cam to be compiled, but will not detect any cameras during runtime (since IDS camera daemon is not packaged in unofficial driver download)
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 11 Dec 2014 05:00:00 -0000

ros-indigo-ueye-cam (1.0.4-0trusty) trusty; urgency=high

  * Switching to DownloadUEyeDriversUnofficial.cmake (based on ueye ROS package) until IDS grants official permission
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 01 Dec 2014 05:00:00 -0000

ros-indigo-ueye-cam (1.0.3-0trusty) trusty; urgency=high

  * Dependency switch from 'vision_opencv' meta-package to 'cv_bridge' package
  * trim '/' prefix of topic and service to change to relative name-space
  * Contributors: Anqi Xu, Yutaka Kondo

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Wed, 05 Nov 2014 05:00:00 -0000

ros-indigo-ueye-cam (1.0.2-0trusty) trusty; urgency=high

  * switched from rosdep 'opencv2' to 'vision_opencv'
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 16 Oct 2014 04:00:00 -0000

ros-indigo-ueye-cam (1.0.1-0trusty) trusty; urgency=high

  * Package now attempts to auto-install IDS uEye drivers; prints more useful info for IS_TIMED_OUT errors
  * First attempt at debian-packaging
  * Contributors: Anqi Xu, Dirk Thomas, Juan Camilo Gamboa Higuera, Kei Okada, Yutaka Kondo

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 16 Oct 2014 04:00:00 -0000

=== debian/control ===
Source: ros-indigo-ueye-cam
Section: misc
Priority: extra
Maintainer: Anqi Xu <anqixu@cim.mcgill.ca>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-camera-calibration-parsers, ros-indigo-camera-info-manager, ros-indigo-catkin, ros-indigo-dynamic-reconfigure, ros-indigo-image-transport, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-ueye-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-camera-calibration-parsers, ros-indigo-camera-info-manager, ros-indigo-dynamic-reconfigure, ros-indigo-image-transport, ros-indigo-nodelet, ros-indigo-roscpp, ros-indigo-sensor-msgs
Description: A ROS nodelet and node that wraps the driver API for UEye cameras by IDS Imaging Development Systems GMBH.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-ueye-cam//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
